﻿using System;
using System.Collections.Generic;
using System.Text;

using Com.Piwigo.Lib.DTO;
using System.Web;
using Com.Piwigo.Lib.Proxy.Response;
using Com.Piwigo.Lib.Proxy.Helper;

namespace Com.Piwigo.Lib.Proxy
{
    static class PwgCategoriesProxy
    {
        static public PwgCategoriesProxyResponse pwg_categories_getList(Int32? CategoryId, 
            Boolean? Recursive, Boolean? PublicOnly)
        {
            PwgCategoriesProxyResponse response = null;
            try
            {
                StringBuilder data = new StringBuilder();
                Boolean firstOcc = true;

                PwgProxyReponseHelper.buildQueryFromValue<Int32>(CategoryId, "cat_id", ref firstOcc, data);
                PwgProxyReponseHelper.buildQueryFromValue<Boolean>(Recursive, "recursive", ref firstOcc, data);
                PwgProxyReponseHelper.buildQueryFromValue<Boolean>(PublicOnly, "public", ref firstOcc, data);

                response = PwgGenericProxy<PwgCategoriesProxyResponse>.Get(
                                PwgConfigProxy.PwgServeurUriBuilder.Uri,
                                "pwg.categories.getList", data.ToString());
            }
            catch (Exception ex)
            {
                throw new PwgProxyException("pwg_categories_getList", ex);
            }
            return response;

        }

        static public PwgCategoriesProxyResponse pwg_categories_getAdminList()
        {
            PwgCategoriesProxyResponse response = null;
            try
            {
                response = PwgGenericProxy<PwgCategoriesProxyResponse>.Get(
                                PwgConfigProxy.PwgServeurUriBuilder.Uri,
                                "pwg.categories.getAdminList", null);
            }
            catch (Exception ex)
            {
                throw new PwgProxyException("pwg_categories_getAdminList", ex);
            }
            return response;

        }

        static public PwgAddRequestProxyResponse pwg_categories_add(String categorieName, Int32? IdUpperCat)
        {
            PwgAddRequestProxyResponse response = null;
            try
            {
                StringBuilder data = new StringBuilder();
                data.Append("method=pwg.categories.add");
                Boolean firstOcc = false;
                PwgProxyReponseHelper.buildQueryFromValue<String>(categorieName, "name", ref firstOcc, data);
                PwgProxyReponseHelper.buildQueryFromValue<Int32>(IdUpperCat, "parent", ref firstOcc, data);

                response = PwgGenericProxy<PwgAddRequestProxyResponse>.Post(
                    PwgConfigProxy.PwgServeurUriBuilder.Uri,
                    data.ToString());
            }
            catch (Exception ex)
            {
                throw new PwgProxyException("pwg_categories_add", ex);
            }

            return response;
        }


    }

}

