﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using Com.Piwigo.Lib.DTO;

namespace Com.Piwigo.Lib.Proxy.Response
{
    [Serializable()]
    [XmlRoot(ElementName = "category")]
    public class PwgCategoryProxyResponse
    {
        [XmlAttribute(AttributeName = "id")]
        public Int32 Id { get; set; }
        [XmlElement(ElementName = "uppercats")]
        public String UpperCategoryId { get; set; }
        [XmlElement (ElementName = "name")]
        public String Name { get; set; }
        [XmlAttribute(AttributeName = "url")]
        public String Url { get; set; }
        [XmlAttribute(AttributeName = "nb_images")]
        public Int64 ImagesCount { get; set; }
        [XmlAttribute(AttributeName = "total_nb_images")]
        public Int64 DeepImagesCount { get; set; }
        [XmlAttribute(AttributeName = "nb_categories")]
        public Int64 SubCategoriesCount { get; set; }
        [XmlAttribute(AttributeName = "max_date_last")]
        public String LastDate { get; set; }
    }

    [Serializable()]
    [XmlRoot(ElementName = "rsp")]
    public class PwgCategoriesProxyResponse : PwgBaseProxyReponse
    {
        [XmlArray("categories")]
        [XmlArrayItem("category")]
        public PwgCategoryProxyResponse[] Categories { get; set; }
    }
}
